#ifndef _SAUCER_BLOCK_H_INCLUDED_
#define _SAUCER_BLOCK_H_INCLUDED_

typedef struct _Block *Block;

typedef enum {
  BLOCK_STATUS_UNCLEAR,
  BLOCK_STATUS_TRY,
  BLOCK_STATUS_ATTACK,
  BLOCK_STATUS_CLEARING,
  BLOCK_STATUS_CLEARED,
} BlockStatus_t;

#include "Saucer.h"
#include "Canon.h"
#include "Piece.h"
#include "Log.h"

Block Block_Create(int track, int sector, Saucer saucer, Question question);
Block Block_Destroy(Block block);
int Block_Proc(Block block);
int Block_MakePolygon(Block block);
BlockStatus_t Block_GetStatus(Block block);
BlockStatus_t Block_SetStatus(Block block, BlockStatus_t status);
Question Block_GetQuestion(Block block);
Question Block_SetQuestion(Block block, Question question);
int Block_AddCanon(Block block, Canon canon, BlockStatus_t status);
int Block_AddPiece(Block block, Piece piece);

#endif
